static char ladders[15][7]=
  { /* Majeur     */ {5,5,3,5,5,5,3}
  , /* Harmonisch */ {5,3,5,5,3,7,3}
  , /* Melodisch  */ {5,3,5,5,5,5,3}
  , /* Lydisch    */ {5,5,5,3,5,5,3}
  , /* Mixolydisch*/ {5,5,3,5,5,3,5}
  , /* Dorisch    */ {5,3,5,5,5,3,5}
  , /* Eolisch    */ {5,3,5,5,3,5,5}
  , /* Frygisch   */ {3,5,5,5,3,5,5}
  , /* Lokerisch  */ {3,5,5,3,5,5,5}
  , /* Lydo-mixoly*/ {5,5,5,3,5,3,5}
  , /* iono-fryg  */ {5,5,3,5,3,5,5}
  , /* zig majeur */ {3,7,3,5,3,7,3}
  , /* zig mineur */ {5,3,7,3,3,7,3}
  , /* islam      */ {3,7,3,3,7,3,5}
  , /* moll-dur   */ {5,5,3,5,3,7,3} 
  };

static char chroma[]    = {2,3,2,3,3,2,3,2,3,2,3,3};

static char akkoord[13][4]=
  { /* Dominant          */   { 10,8,8,5}
  , /* Groot             */   { 10,8,10,3}
  , /* Klein-verminderd  */   { 8,10,6,7}   
  , /* Klein             */   { 8,10,8,5}
  , /* Klein-groot       */   { 8,10,10,3}
  , /* Verminderd        */   { 8,8,8,7}
  , /* Halfverminderd    */   { 8,8,10,5}
  , /* Overmatig dominant*/   { 10,10,6,5}
  , /* Overmatig         */   { 10,10,8,3}
  , /* Hardverminderd    */   { 10,6,10,5}
  , /* Dubbelverminderd  */   { 6,10,8,7}
  , /* Dubbelverm. klein */   { 6,10,10,5}
  , /* User-defined      */   { 10,8,7,6}
  };

static char map3112[32] = {0,0,1,1,2,2,2,3,3,4,4,4,5,5,5,6,6,7,7,7,8,8,9,9,9,10,10,11,11,11,12,12};

static int mappiano[5][12] = 
{ /*12-toons*/ { C,  Cis,D,  Es, E,  F,  Fis,G,  Gis,A,  Bes,B  }
, /*Pythago */ { C,  Cis,D,  Es, E,  F,  Fis,G,  Gis,A,  Bes,B  }
, /*Midden  */ { C,  Cis,D,  Es, E,  F,  Fis,G,  Gis,A,  Bes,B  }
, /*Euler   */ { C,  Cis,D,  Es, E,  F,  Fis,G,  Gis,A,  Bes,B  }
, /*user    */ { C,  Cis,D,  Es, E,  F,  Fis,G,  Gis,A,  Bes,B  }
};

#define LAGEC12   32.70319566
#define LAGEC31   32.88651504
#define LAGECPYTH 32.59259259
#define LAGECMIDD 32.8976732

float lagec[5] = 
{     LAGEC12
,     LAGECPYTH
,     LAGECMIDD
,     LAGEC31
,     LAGEC31
};


#define TB 26        /* toetsbreedte               */
#define TR 30        /* toetsruimte                */
#define TS 2         /* witte rand om toets        */
#define LM 5         /* left margin                */
#define BM 30        /* bottom margin              */
#define HTR 15       /* halve TR                   */
#define TBB 21       /* toetsenbordbreedte         */
#define TBH 7        /* toetsenbordhoogte          */

#define WT 0         /* kleur van de toetsen       */
#define KR 8
#define ML 6
#define HK 4
#define HM 2


static char toetskleur[TBH][TBB]=
  {  {WT,WT,WT,KR,KR,KR,HM,HM,HM,HK,HK,HK,HK,ML,ML,WT,WT,WT,WT,KR,0}
  , {HK,ML,ML,WT,WT,WT,WT,KR,KR,HM,HM,HM,HM,HK,HK,HK,ML,ML,ML,WT,WT}
  ,  {HK,HK,HK,ML,ML,ML,WT,WT,WT,KR,KR,KR,HM,HM,HM,HK,HK,HK,HK,ML,0}
  , {HM,HM,HM,HK,HK,HK,HK,ML,ML,WT,WT,WT,WT,KR,KR,HM,HM,HM,HM,HK,HK}
  ,  {KR,KR,HM,HM,HM,HM,HK,HK,HK,ML,ML,ML,WT,WT,WT,KR,KR,KR,HM,HM,0}
  , {WT,WT,WT,KR,KR,KR,HM,HM,HM,HK,HK,HK,HK,ML,ML,WT,WT,WT,WT,KR,KR}
  ,  {ML,ML,WT,WT,WT,WT,KR,KR,HM,HM,HM,HM,HK,HK,HK,ML,ML,ML,WT,WT,0}
  };

static int archnoot[TBH][TBB]=
  {   {c1,  d1,  e1,  fis1,gis1,ais1,ceh1,deh2,eh2, fi2, gi2, ai2, bi2, des3,es3, f3,  g3,  a3,  b3,  cis4,cis4 }
  , {bi0, des1,es1, f1,  g1,  a1,  b1,  cis2,dis2,feh2,geh2,ah2, beh2,ci3, di3, ei3, ges3,as3, bes3,c4,  d4  }
  ,   {ci1, di1, ei1, ges1,as1, bes1,c2,  d2,  e2,  fis2,gis2,ais2,ceh2,deh3,eh3, fi3, gi3, ai3, bi3, des4,des4 }
  , {ceh0,deh1,eh1, fi1, gi1, ai1, bi1, des2,es2, f2,  g2,  a2,  b2,  cis3,dis3,feh3,geh3,ah3, beh3,ci4, di4 }
  ,   {cis1,dis1,feh1,geh1,ah1, beh1,ci2, di2, ei2, ges2,as2, bes2,c3,  d3,  e3,  fis3,gis3,ais3,ceh3,deh4,deh4 }
  , {c1,  d1,  e1,  fis1,gis1,ais1,ceh1,deh2,eh2, fi2, gi2, ai2, bi2, des3,es3, f3,  g3,  a3,  b3,  cis4,dis4}
  ,   {des1,es1, f1,  g1,  a1,  b1,  cis2,dis2,feh2,geh2,ah2, beh2,ci3, di3, ei3, ges3,as3, bes3,c4,  d4,  d4 }
  };

static char pianonoot[96]=
  {12,12,12,13,13,14,14,15,15,16,16,16,17,17,17,18,18,19,19,20,20,21,21,22,22,23,23,23
  ,24,24,24,25,25,26,26,27,27,28,28,28,29,29,29,30,30,31,31,32,32,33,33,34,34,35,35,35
  ,36,36,36,37,37,38,38,39,39,40,40,40,41,41,41,42,42,43,43,44,44,45,45,46,46,47,47,47
  ,48,48,48,49,49,50,50,51,51,52,52,52
  };

